<?php

static $client_id = "PHPTutorial";
static $endpoint = "https://rest.smartvault.com";
static $email= "phpexample@smartvault.com";
$private_key = "<RSAKeyValue><Modulus>qqwkHMTo+/gFeUtafHP3bRBAztIz6wmiLXaSV/
				WhmZZoUGJqDXOnZwIdWDIs39BeJU5wqUu7yJzFn/JoZs4qH3YhSP8auPtbnu
				eNnYU8sLA0pkEd14PRZIAQeoE5USEtNGV3t3L6uaTC0NYemWnqcGHXsJ8qLX
				9DYw50LCT/JlO19t4NRcnJNxwkbBDZ0lQZt3gE/xY1Ut3LmE9UHOV6usU8Ou
				/NriOOhWHCS+yaN+JeefXkq9jZWYPhr53ZTtNd3j39CSL+fbXJ2dDrsx2NJe
				RJ2lm8OBw+F14L3a30I/GA5gobZ/ny+K4qtCpvhE+GuhM6sEJ+XgguHleP8T
				CnZQ==</Modulus><Exponent>AQAB</Exponent><P>y8lNtyFth443JHdl
				5nr/Vt2U6H1GoSEqExpTTM/eghJ/UZBo0Uu59NzCmrSCDIHbars9S8fu3ud4
				YRfJdYHjWurfY7oC+VfdQLSjgjmncGzA+U+Zrfq8K8zDdheWFRwMG5Nxa1dJ
				wFkry00UZMKOpeV7Y/4/pNVjpgnW1hsfE8M=</P><Q>1mbWvPzBMWQIJUtiw
				DtDc3rzQe7KwyLEzxj7ujCGG3rlo5HuVw5h+XKmE6ZtPz3h+gBkYIr4Xw1FE
				lFxGUJtc8hwLbVTPvsluM6rzYkicOqwdlfOrv+T0ROYHkCHoiLt6B+6ulIUV
				1kP71J3v4UFh/WQtOK3aup862MmDg+67bc=</Q><DP>jxIOUMLUPfY3eo+k5
				/J0b8zzLWI+gwNgoba6wtOxmMpZvq7PGBm9PU78BVczcop8vGsmNpzwdGg32
				Jq1op0FPKBnI4HFcr8gI7xuiw/lIQYJWT9sWnwNPgbtN2yJvtpJGdcjKsRGk
				BdKqtm7tp3tPkVloqcukZAK/Ngtj3XNFLc=</DP><DQ>coipengDtKDdgR7O
				eCawl8Y8oSIxiyDNxlxwTTySx6dVeZYBntv+FsXaVnD3t2sVhvoipThYCl8K
				YQjExFuqIMoYszJEcEa2Fg3B1aDGl0+oSPALZ4z8qBoxjyelzUWflfstQ0+J
				skfPrWd+tP8Yv1K9pQPgO+tcJFro/2YD0+0=</DQ><InverseQ>RZoAXQtlg
				XiisdfFARu6t9Xj1W+zTpy7XwHZUqpDL/piD1biMLa913s8mKK4WRh+e+912
				QllaIgC6tA61xRS7MzRQDgvW6K6rRVZidSxP8ruhk6lkcL4DQGljqdli3Wby
				Bu1tOJ6mOf83bX4R/8xQY74nIp89YJC5SLVzgoAvgg=</InverseQ><D>G8H
				ovaUTdKdfJzL81xt6ijUH1UXqm7dIC7d/uukqtx1MfzECU92+GXVb6xQoqDN
				DRzNSr2CvJxltgBifUi5a5h2tnCmhNvnqahWkD+ezedOukbuAFvpL+9m4KbR
				f619HSCuYejArsYr9BD9OtV9nJDqa0bw70oUizeFz6MS7mofkH4CKoB5gBFM
				cXPEZHt98gSbmmDKYWE1oOBJXIuOdFTGAs/IKMXhsCLB8cHKXaILa+1Fx40V
				SzeOtMQAaXMc5xvRacPu/iazl+qu+/inIL3Njzr/i4DIas8+lkLC8tqBprvQ
				vxihNqU9uBcHDisUNgc2vJKpSpfYwoxzpWFXkoQ==</D></RSAKeyValue>";

function request_nonce( &$callback )
{
	global $endpoint;
	global $client_id;
	$uri = $endpoint . "/auto/auth/nonce/1";
	
	$http_body = new http\Message\Body();
	$http_body->append( json_encode( array( "client_id" => $client_id ) ) );
	
	$headers = array( "accept" => "application/json" );
	
	$http_client = new http\Client();
	$http_request = new http\Client\Request( "POST", $uri, $headers, $http_body );
	$http_request->setContentType( "application/json" );
	
	$http_client->enqueue( $http_request, $callback );
	return $http_client->send();
}

function generate_self_token( &$nonce )
{
	global $client_id;
	global $private_key;
	$prefix = "SLF00";
	
	$data = array();
	
	$temp = unpack( "C*", $prefix );
	$data = array_merge( $data, $temp );
	
	$data[] = strlen( $client_id );
	$temp = unpack( "C*", $client_id );
	$data = array_merge( $data, $temp );
	
	$data[] = strlen( $nonce );
	$temp = unpack( "C*", $nonce );
	$data = array_merge( $data, $temp );
	
	print json_encode( $data ) . "\n";
	
	$blob = join ( "", array_map( function ( &$i ) 
	{ 
		return chr( $i ); 
	}, 
	$data ) );
	
	$signature = "";
	openssl_sign( $blob, $signature, $private_key, OPENSSL_ALGO_SHA256 );
	
	print "blob: " . bin2hex( $blob ) . "\n";
	print "signature: " . bin2hex( $signature ) . "\n";
	
	$token = base64_encode( $blob . $signature );
	print  "token: " . $token . "\n";
	
	return $token;
}

function request_delegation_token( &$client_token, &$callback )
{
global $endpoint;
    	global $client_id;
    	global $email;

    	$uri = $endpoint . "/auto/auth/dtoken/1";

    	$http_body = new http\Message\Body();
    	$http_body->append( json_encode( array( "user_email" => $email ) ) );

    	$headers = array( "accept" => "application/json" );

    	$auth_basic = 1; // pulled from docs

    	$http_client = new http\Client();
$http_client->setOptions( array( "httpauthtype" => $auth_basic, "httpauth" => $client_id . ":" . $client_token ) );

    	print "Client token: " . $client_token . "\n";

    	$http_request = new http\Client\Request( "POST", $uri, $headers, $http_body );
    	$http_request->setContentType( "application/json" );

    	$action = function ( &$response ) use ( $callback ) 
{
       	print $response->toString() . "\n";

        	$response_code = $response->getTransferInfo()->response_code;
        	$body = $response->getBody();
        	$envelope = json_decode( $body );

        	if ( 200 == $response_code && true == $envelope->error->success ) 
		{
            		$callback( $envelope->message->token );
   		}
    	};

    	$http_client->enqueue( $http_request, $action );
    	return $http_client->send();
}
  
function stat_user( &$client_token, &$callback )
{
	global $endpoint;
    	global $client_id;
    	global $email;

    	$uri = $endpoint . "/auto/usr/" . $email;

    	$headers = array( "accept" => "application/json" );

    	$auth_basic = 1;

    	$http_client = new http\Client();
$http_client->setOptions( array( "httpauthtype" => $auth_basic, "httpauth" => $client_id . ":" . $client_token ) );

    	$http_request = new http\Client\Request( "GET", $uri, $headers );
    	$http_request->setContentType( "application/json" );

    	$action = function ( &$response ) use ( $client_token, $callback ) 
	{
        	print $response->toString() . "\n";

        	$response_code = $response->getTransferInfo()->response_code;
        	$body = $response->getBody();
        	$envelope = json_decode( $body );

        	if ( 200 == $response_code && true == $envelope->error->success ) 
		{
            		print "User statted correctly\n";

            		if ( !$envelope->message->activated ) 
			{
                		print "User needs to activate their account";
            		}
            		elseif ( !$envelope->message->authorized ) 
			{
                		print "User needs to authorize their account for your client:\n  ";
                		print $envelope->message->authorization_uri . "\n";

                		/*
                  		You can add a redirect_uri=some_url as a URL
                 		parameter to that link to send the user back to your
                  		page after they authorize.
                		*/
            		}
            		else 
			{
                		request_delegation_token( $client_token, $callback );
            		}
    		}
};
$http_client->enqueue( $http_request, $action );
return $http_client->send();
}

function request_client_token( &$self_token, &$callback )
{
	global $endpoint;

    $uri = $endpoint . "/auto/auth/ctoken/1";

    $http_body = new http\Message\Body();
    $http_body->append( json_encode( array( "token" => $self_token ) ) );

    $headers = array(
        "accept" => "application/json"
    );

    $http_client = new http\Client();
    $http_request = new http\Client\Request(
        "POST",
        $uri,
        $headers,
        $http_body
    );
    $http_request->setContentType( "application/json" );

    $action = function ( &$response ) use ( $callback ) {

        print $response->toString() . "\n";

        $response_code = $response->getTransferInfo()->response_code;
        $body = $response->getBody();
        $envelope = json_decode( $body );

        if ( 200 == $response_code && true == $envelope->error->success ) {

            print "Do something with the client token\n";
            $client_token = $envelope->message->token;

            stat_user( $client_token, $callback );
        }

    };

    $http_client->enqueue( $http_request, $action );
    return $http_client->send();
}

function authenticate( &$callback )
{
	$nonce_callback = function ( &$response ) use ( $callback ) 
	{
		print $response->toString() . "\n";

		$response_code = $response->getTransferInfo()->response_code;
		$body = $response->getBody();
		$envelope = json_decode( $body );

		if ( 200 == $response_code && true == $envelope->error->success ) 
		{
			$nonce = $envelope->message->code;
			$self_token = generate_self_token( $nonce );
			request_client_token( $self_token, $callback );
		}
	};
	$http_client = request_nonce( $nonce_callback );
}

$fetch_data = function ( &$delegation_token ) {

    print "fetching data\n";

    global $sv_host;
    global $sv_user_email;

    $uri = $sv_host . "/nodes/pth/?children=2";

    $headers = array(
        "accept" => "application/json"
    );

    $auth_basic = 1; // pulled from docs

    $http_client = new http\Client();
    $http_client->setOptions( array(
        "httpauthtype" => $auth_basic,
        "httpauth" => $sv_user_email . ":" . $delegation_token
    ) );

    $http_request = new http\Client\Request(
        "GET",
        $uri,
        $headers
    );
    $http_request->setContentType( "application/json" );

    $action = function ( &$response ) {

        print $response->toString() . "\n";

    };

    $http_client->enqueue( $http_request, $action );
    return $http_client->send();

};

authenticate( $fetch_data )     

?>